/* WLWidgetOrganizerObject */

#import <Cocoa/Cocoa.h>
#import <WebKit/WebKit.h>
#import "WLWidgetHolder.h"
#import "WLWidgetsInDashboard.h"
#import <objc/objc-runtime.h>
//extern class DashboardWebView;

@interface WLWidgetOrganizerObject : NSObject
{
    IBOutlet NSTableView *widgetTableView;
    IBOutlet NSImageView *widgetSystemImageView;
    IBOutlet NSArrayController *widgetArrayController;
    IBOutlet NSPopUpButton *widgetFirstSortButton;
    IBOutlet NSPopUpButton *widgetSecondSortButton;
    IBOutlet NSButton *widgetFirstSortReverseButton;
    IBOutlet NSButton *widgetSecondSortReverseButton;
    IBOutlet NSButton *applyButton;
    IBOutlet NSTextField *widgetURLText;
    IBOutlet WebView *widgetWebView;
	WLWidgetsInDashboard *presentedWidgets;
	NSMutableArray *systemWidgetArray;
	NSMutableArray *homeWidgetArray;
	NSMutableArray *removedWidgetArray;
	NSMutableArray *otherWidgetArray;
	NSArray *widgetKeysArray;
	
	NSString *widgetURL;
	NSSortDescriptor *widgetSortByName;
	NSSortDescriptor *widgetSortByIdentifier;
	NSSortDescriptor *widgetSortBySafety;
	NSSortDescriptor *widgetSortByFileSize;
	NSSortDescriptor *widgetSortByDate;
	NSSortDescriptor *widgetSortByLocation;
}

- (IBAction)setFirstSortDescriptor:(id)sender;
- (IBAction)setSecondSortDescriptor:(id)sender;
- (IBAction)reverseOneSortDescriptor:(id)sender;
- (IBAction)removeWidgetFromDir:(id)sender;
- (IBAction)quitDockToReloadWidgets:(id)sender;
- (IBAction)reloadWidgetsFromSystemLibrary:(id)sender;
- (IBAction)launchWidgetInDashboard:(id)sender;
- (IBAction)changeWidgetValues:(id)sender;
- (IBAction)changeWidgetDeveloperMode:(id)sender;
- (IBAction)displayWidgetPreview:(id)sender;
- (IBAction)changePresentedWidgets:(id)sender;
- (void) removeWidgetFromArrays: (WLWidgetHolder *) aWidgetHolder;
- (IBAction)imitateDashboardTransparency:(id)sender;

- (void)loadWidgetsFromSystemLibrary;
- (void) displayWidgetPreview;

// method for application delegate
// if this object is inside a prefpane, this method is obsolete
// because the traget is not set here
- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication;
// Tableview delegate method, invoked, if the selection is changed via mouse click
// not keyboard arrows, but it is sufficient here
-(void)handleTimedControllStateAfterBindingKickedIn:(NSTimer *)timer;

- (void)tableView:(NSTableView*)tableView didClickTableColumn:(NSTableColumn *)tableColumn;
//- (void) observerMethod:(id)aNotification;
//- (void)fileManager:(NSFileManager *)manager willProcessPath:(NSString *)path;

- (void) removeSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)aWidgetHolder;
- (WLWidgetHolder *)widgetHasInstalledTwin:(WLWidgetHolder *)aWidgetHolder;
- (NSString *)widgetURL;
- (void)setWidgetURL: (NSString *)newURL;
//void  ShowAllMyPreciousClasses()

- (void)didEndSheet:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;


@end
